#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Lime
#property indicator_color2 Red
//#property indicator_level1 0
//#property indicator_levelcolor 1776411
//#property indicator_levelstyle 0

enum ma_pr{tied,proportional,free};
input ma_pr          Ma_pr      = tied;
input int            Ma         = 9;
input bool           Calc0    = true;
input bool           Calc1    = true;
input bool           Calc2    = true;
input bool           Calc3    = true;
input bool           Calc4    = true;
input bool           Calc5    = true;
input bool           Calc_all = false;

int ma0,ma1,ma2,ma3;
bool C0,C1,C2,C3,C4,C5;
 
double B0[],B1[],Bm0[24][100000], Bm1[24][100000],
       Bp0_0[],Bp0_1[],Bp1_0[],Bp1_1[],Bp2_0[],Bp2_1[],Bp3_0[],Bp3_1[],Bp4_0[],Bp4_1[],Bp5_0[],Bp5_1[];

int init() {
   IndicatorBuffers(14);
   SetIndexBuffer(0,B0); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,B1); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,Bp0_0); SetIndexBuffer(3,Bp0_1); SetIndexBuffer(4,Bp1_0);  SetIndexBuffer(5,Bp1_1);  SetIndexBuffer(6,Bp2_0);  SetIndexBuffer(7,Bp2_1);
   SetIndexBuffer(8,Bp3_0); SetIndexBuffer(9,Bp3_1); SetIndexBuffer(10,Bp4_0); SetIndexBuffer(11,Bp4_1); SetIndexBuffer(12,Bp5_0); SetIndexBuffer(13,Bp5_1);
   IndicatorShortName("Cloud_"+Ma_pr+"_"+Ma);
   switch(Ma_pr){case tied:         ma2=Ma*2.78; ma0=Ma*4.17; ma1=Ma*5.56; ma3=Ma*6.94;break;
                 case proportional: ma2=Ma*2;    ma0=Ma*3;    ma1=Ma*4;    ma3=Ma*5;break;
                 case free:         ma2=Ma*0.5;  ma0=Ma*0.75; ma1=Ma;      ma3=Ma*1.25;break;}  
   if(Calc_all==false){C0=Calc0; C1=Calc1; C2=Calc2; C3=Calc3; C4=Calc4; C5=Calc5;}else
                      {C0=true;  C1=true;  C2=true;  C3=true;  C4=true;  C5=true;}
   return (0);
}

int start(){int i,limit=Bars-IndicatorCounted()-1;

   for(i=limit;i>=0;i--){
     Bp0_0[i]= (Close[i]             -Low[i+1]);                                                       Bp0_1[i]=(High[i+1]                                                      -Close[i]);
     Bp1_0[i]= (Close[i]             -MathMin(Low[i],Close[i+1]));                                     Bp1_1[i]=(MathMax(High[i],Close[i+1])                                    -Close[i]);
     Bp2_0[i]= (Close[i]             -MathMin(Low[i],Close[i+1])-(MathMin(Open[i],Close[i])-Low[i]));  Bp2_1[i]=(MathMax(High[i],Close[i+1])-(High[i]-MathMax(Open[i],Close[i]))-Close[i]);
     Bp3_0[i]= (Close[i]             -((High[i+1]+Low[i+1])*0.5));                                     Bp3_1[i]=(((High[i+1]+Low[i+1])*0.5)                                     -Close[i]);
     Bp4_0[i]= (Close[i]             -MathMin(Open[i+1],Close[i+1]));                                  Bp4_1[i]=(MathMax(Open[i+1],Close[i+1])                                  -Close[i]);
     Bp5_0[i]=((Close[i]+High[i])*0.5-MathMin(Low[i],Low[i+1]));                                       Bp5_1[i]=(MathMax(High[i],High[i+1])                                     -(Close[i]+Low[i])*0.5);}

   for(i=limit;i>=0;i--){double bb,hh=0,hl=0;
                         if(C0==true){Bm0[1 ][i]=iMAOnArray(Bp0_0,0,ma0,0,0,i); Bm1[1 ][i]=iMAOnArray(Bp0_1,0,ma0,0,0,i); bb=Bm0[1 ][i]-Bm1[1 ][i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                                      Bm0[2 ][i]=iMAOnArray(Bp0_0,0,ma1,0,1,i); Bm1[2 ][i]=iMAOnArray(Bp0_1,0,ma1,0,1,i); bb=Bm0[2 ][i]-Bm1[2 ][i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                                      Bm0[3 ][i]=iMAOnArray(Bp0_0,0,ma2,0,2,i); Bm1[3 ][i]=iMAOnArray(Bp0_1,0,ma2,0,2,i); bb=Bm0[3 ][i]-Bm1[3 ][i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                                      Bm0[4 ][i]=iMAOnArray(Bp0_0,0,ma3,0,3,i); Bm1[4 ][i]=iMAOnArray(Bp0_1,0,ma3,0,3,i); bb=Bm0[4 ][i]-Bm1[4 ][i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}}
                         if(C1==true){Bm0[5 ][i]=iMAOnArray(Bp1_0,0,ma0,0,0,i); Bm1[5 ][i]=iMAOnArray(Bp1_1,0,ma0,0,0,i); bb=Bm0[5 ][i]-Bm1[5 ][i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                                      Bm0[6 ][i]=iMAOnArray(Bp1_0,0,ma1,0,1,i); Bm1[6 ][i]=iMAOnArray(Bp1_1,0,ma1,0,1,i); bb=Bm0[6 ][i]-Bm1[6 ][i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                                      Bm0[7 ][i]=iMAOnArray(Bp1_0,0,ma2,0,2,i); Bm1[7 ][i]=iMAOnArray(Bp1_1,0,ma2,0,2,i); bb=Bm0[7 ][i]-Bm1[7 ][i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                                      Bm0[8 ][i]=iMAOnArray(Bp1_0,0,ma3,0,3,i); Bm1[8 ][i]=iMAOnArray(Bp1_1,0,ma3,0,3,i); bb=Bm0[8 ][i]-Bm1[8 ][i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}}
                         if(C2==true){Bm0[9 ][i]=iMAOnArray(Bp2_0,0,ma0,0,0,i); Bm1[9 ][i]=iMAOnArray(Bp2_1,0,ma0,0,0,i); bb=Bm0[9 ][i]-Bm1[9 ][i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                                      Bm0[10][i]=iMAOnArray(Bp2_0,0,ma1,0,1,i); Bm1[10][i]=iMAOnArray(Bp2_1,0,ma1,0,1,i); bb=Bm0[10][i]-Bm1[10][i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                                      Bm0[11][i]=iMAOnArray(Bp2_0,0,ma2,0,2,i); Bm1[11][i]=iMAOnArray(Bp2_1,0,ma2,0,2,i); bb=Bm0[11][i]-Bm1[11][i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                                      Bm0[12][i]=iMAOnArray(Bp2_0,0,ma3,0,3,i); Bm1[12][i]=iMAOnArray(Bp2_1,0,ma3,0,3,i); bb=Bm0[12][i]-Bm1[12][i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}}
                         if(C3==true){Bm0[13][i]=iMAOnArray(Bp3_0,0,ma0,0,0,i); Bm1[13][i]=iMAOnArray(Bp3_1,0,ma0,0,0,i); bb=Bm0[13][i]-Bm1[13][i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                                      Bm0[14][i]=iMAOnArray(Bp3_0,0,ma1,0,1,i); Bm1[14][i]=iMAOnArray(Bp3_1,0,ma1,0,1,i); bb=Bm0[14][i]-Bm1[14][i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                                      Bm0[15][i]=iMAOnArray(Bp3_0,0,ma2,0,2,i); Bm1[15][i]=iMAOnArray(Bp3_1,0,ma2,0,2,i); bb=Bm0[15][i]-Bm1[15][i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                                      Bm0[16][i]=iMAOnArray(Bp3_0,0,ma3,0,3,i); Bm1[16][i]=iMAOnArray(Bp3_1,0,ma3,0,3,i); bb=Bm0[16][i]-Bm1[16][i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}}
                         if(C4==true){Bm0[17][i]=iMAOnArray(Bp4_0,0,ma0,0,0,i); Bm1[17][i]=iMAOnArray(Bp4_1,0,ma0,0,0,i); bb=Bm0[17][i]-Bm1[17][i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                                      Bm0[18][i]=iMAOnArray(Bp4_0,0,ma1,0,1,i); Bm1[18][i]=iMAOnArray(Bp4_1,0,ma1,0,1,i); bb=Bm0[18][i]-Bm1[18][i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                                      Bm0[19][i]=iMAOnArray(Bp4_0,0,ma2,0,2,i); Bm1[19][i]=iMAOnArray(Bp4_1,0,ma2,0,2,i); bb=Bm0[19][i]-Bm1[19][i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                                      Bm0[20][i]=iMAOnArray(Bp4_0,0,ma3,0,3,i); Bm1[20][i]=iMAOnArray(Bp4_1,0,ma3,0,3,i); bb=Bm0[20][i]-Bm1[20][i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}}
                         if(C5==true){Bm0[21][i]=iMAOnArray(Bp5_0,0,ma0,0,0,i); Bm1[21][i]=iMAOnArray(Bp5_1,0,ma0,0,0,i); bb=Bm0[21][i]-Bm1[21][i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                                      Bm0[22][i]=iMAOnArray(Bp5_0,0,ma1,0,1,i); Bm1[22][i]=iMAOnArray(Bp5_1,0,ma1,0,1,i); bb=Bm0[22][i]-Bm1[22][i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                                      Bm0[23][i]=iMAOnArray(Bp5_0,0,ma2,0,2,i); Bm1[23][i]=iMAOnArray(Bp5_1,0,ma2,0,2,i); bb=Bm0[23][i]-Bm1[23][i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}
                                      Bm0[24][i]=iMAOnArray(Bp5_0,0,ma3,0,3,i); Bm1[24][i]=iMAOnArray(Bp5_1,0,ma3,0,3,i); bb=Bm0[24][i]-Bm1[24][i]; if(bb>hh){hh=bb;}else if(bb<hl){hl=bb;}} B0[i]=hh; B1[i]=hl;}
   return (0);
}